"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _assert = _interopRequireDefault(require("assert"));

var _Plugin = _interopRequireDefault(require("./Plugin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _default(_ref) {
  var types = _ref.types;
  var plugins = null;
  var referPlugins = []; // Only for test

  global.__clearBabelAntdPlugin = function () {
    plugins = null;
  };

  function applyInstance(method, args, context) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = plugins[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var plugin = _step.value;

        if (plugin[method]) {
          plugin[method].apply(plugin, _toConsumableArray(args).concat([context]));
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  function getRefreOptions(opts) {
    if (referPlugins.indexOf(function (plugin) {
      return plugin.libraryName === opts.libraryName2;
    }) < 0) {
      var camel2DashComponentName = opts.camel2DashComponentName,
          camel2UnderlineComponentName = opts.camel2UnderlineComponentName,
          camel2DashComponentName2 = opts.camel2DashComponentName2,
          camel2UnderlineComponentName2 = opts.camel2UnderlineComponentName2;
      return {
        libraryName: opts.libraryName2 || opts.libraryName,
        libraryDirectory: opts.libraryDirectory2 || opts.libraryDirectory,
        style: opts.style2 || opts.style,
        camel2DashComponentName: camel2DashComponentName2 || camel2DashComponentName,
        camel2UnderlineComponentName: camel2UnderlineComponentName2 || camel2UnderlineComponentName,
        fileName: opts.fileName2 || opts.fileName,
        customName: opts.customName2 || opts.customName
      };
    }

    return null;
  }

  function newPlugin(opts) {
    var libraryName = opts.libraryName,
        libraryName2 = opts.libraryName2,
        libraryDirectory = opts.libraryDirectory,
        style = opts.style,
        camel2DashComponentName = opts.camel2DashComponentName,
        camel2UnderlineComponentName = opts.camel2UnderlineComponentName,
        fileName = opts.fileName,
        customName = opts.customName;
    (0, _assert.default)(libraryName, 'libraryName should be provided');
    var referOption = libraryName2 ? getRefreOptions(opts) : null;
    var referPlugin = referOption ? newPlugin(referOption) : null;

    if (referPlugin) {
      referPlugins.push(referPlugin);
    }

    return new _Plugin.default(libraryName, libraryDirectory, style, camel2DashComponentName, camel2UnderlineComponentName, fileName, customName, types, referPlugin);
  }

  var Program = {
    enter: function enter(path, _ref2) {
      var _ref2$opts = _ref2.opts,
          opts = _ref2$opts === void 0 ? {} : _ref2$opts;

      // Init plugin instances once.
      if (!plugins) {
        referPlugins = [];

        if (Array.isArray(opts)) {
          plugins = opts.map(function (element) {
            return newPlugin(element);
          });
        } else {
          (0, _assert.default)(opts.libraryName, 'libraryName should be provided');
          plugins = [newPlugin(opts)];
        }

        plugins = plugins.concat(referPlugins);
      }

      applyInstance('ProgramEnter', arguments, this); // eslint-disable-line
    },
    exit: function exit() {
      applyInstance('ProgramExit', arguments, this); // eslint-disable-line
    }
  };
  var methods = ['ImportDeclaration', 'CallExpression', 'MemberExpression', 'Property', 'VariableDeclarator', 'ArrayExpression', 'LogicalExpression', 'ConditionalExpression', 'IfStatement', 'ExpressionStatement', 'ReturnStatement', 'ExportDefaultDeclaration', 'BinaryExpression', 'NewExpression'];
  var ret = {
    visitor: {
      Program: Program
    }
  };

  var _loop = function _loop() {
    var method = methods[_i];

    ret.visitor[method] = function () {
      // eslint-disable-line
      applyInstance(method, arguments, ret.visitor); // eslint-disable-line
    };
  };

  for (var _i = 0; _i < methods.length; _i++) {
    _loop();
  }

  return ret;
}